//
//  VoiceClient.m
//  VoiceToolOSX
//
//  Created by Taihei Monma on Wed Sep 03 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "VoiceClient.h"


@implementation VoiceClient

- (id)initWithAFSPath:(NSString *)path1 savePath:(NSString *)path2
				game:(int)g isMixer:(int)m parent:(id <ControllerProtocol>)aParent
{
	[super init];
	
	airVoice = [[NSArray arrayWithObjects: NSLocalizedString(@"yukito",@""),NSLocalizedString(@"misuzu",@""),NSLocalizedString(@"haruko",@""),NSLocalizedString(@"nazo",@""),NSLocalizedString(@"mother",@""),NSLocalizedString(@"kawaguti",@""),@"",NSLocalizedString(@"girl",@""),NSLocalizedString(@"sister1",@""),NSLocalizedString(@"sister2",@""),NSLocalizedString(@"sinomother",@""),NSLocalizedString(@"kano",@""),NSLocalizedString(@"hijiri",@""),NSLocalizedString(@"potato",@""),NSLocalizedString(@"siraho",@""),NSLocalizedString(@"miya",@""),NSLocalizedString(@"kanomother",@""),NSLocalizedString(@"minagi",@""),NSLocalizedString(@"mitiru",@""),NSLocalizedString(@"minagimother",@""),NSLocalizedString(@"minagifather",@""),NSLocalizedString(@"kanna",@""),NSLocalizedString(@"uraha",@""),NSLocalizedString(@"kannamother",@""),NSLocalizedString(@"titoku",@""),NSLocalizedString(@"other",@""),nil] retain];
	kanonVoice = [[NSArray arrayWithObjects: NSLocalizedString(@"nayuki",@""),NSLocalizedString(@"ayu",@""),NSLocalizedString(@"siori",@""),NSLocalizedString(@"mai",@""),NSLocalizedString(@"makoto",@""),NSLocalizedString(@"akiko",@""),NSLocalizedString(@"kaori",@""),NSLocalizedString(@"sayuri",@""),NSLocalizedString(@"misio",@""),NSLocalizedString(@"kitagawa",@""),NSLocalizedString(@"kuze",@""),NSLocalizedString(@"other",@""),nil] retain];
	
	afsPath = [path1 retain];
	savePath = [path2 retain];
	controller = aParent;
	
	game = g;
	isMixer = m;
	
	return self;
}

- (void)dealloc
{
	[afsPath release];
	[savePath release];
	[kanonVoice release];
	[airVoice release];
	[super dealloc];
}

- (void)doExpand
{
	//NSLog(savePath);
	[NSThread detachNewThreadSelector:@selector(expand)
                             toTarget:self 	withObject:nil];
}

- (void)expand
{
	NSAutoreleasePool *pool;
	pool = [[NSAutoreleasePool alloc] init];
	
	NSFileManager *fm = [NSFileManager defaultManager];
	NSString *afsFile,*path;
	Cadxcut adxcut;
	int ret = 5;
	int i;
	if(game == 0) {
		for(i=0;i<[kanonVoice count];i++) {
			[controller setCurrentProgress2: 0.0];
			afsFile = [NSString stringWithFormat: @"VOICE%X.AFS",i];
			path = [afsPath stringByAppendingPathComponent: afsFile];
			if([fm fileExistsAtPath: path]) {
				[controller setStatusText: [kanonVoice objectAtIndex: i]
						text2: NSLocalizedString(@"expanding",@"")
						text3: [NSString stringWithFormat: @"(%d/%d)",i+1,[kanonVoice count]]];
				ret = adxcut.adxcut([path UTF8String],[savePath UTF8String],0,game,isMixer,controller);
				if(ret != 0) break;
				//[controller setStatusText:@" " text2: @" " text3: @" "];
			}
		}
	}
	else {
		for(i=0;i<[airVoice count];i++) {
			[controller setCurrentProgress2: 0.0];
			afsFile = [NSString stringWithFormat: @"VOICE%02d.AFS",i];
			path = [afsPath stringByAppendingPathComponent: afsFile];
			if([fm fileExistsAtPath: path]) {
				[controller setStatusText: [airVoice objectAtIndex: i]
						text2: NSLocalizedString(@"expanding",@"")
						text3: [NSString stringWithFormat: @"(%d/%d)",i+1,[airVoice count]]];
				ret = adxcut.adxcut([path UTF8String],[savePath UTF8String],0,game,isMixer,controller);
				if(ret != 0) break;
				//[controller setStatusText:@" " text2: @" " text3: @" "];
			}
		}
	}
	[controller setStatusText:@" " text2: @" " text3: @" "];
	[controller expandFinished: ret];
	[pool release];
}
@end
